#define DEFAULT_GINA_PATH   TEXT("MSGINA.DLL")
#define AGENA_VERSION       WLX_VERSION_1_3
#define REGKEY_WINLOGON     \
  TEXT("Software\\Microsoft\\Windows NT\\CurrentVersion\\Winlogon")
#define REGVALUE_GINADLL    TEXT("GinaDLL")

// 1.0 GINA entrypoints

typedef BOOL (WINAPI *FPWLXNEGOTIATE)(DWORD,DWORD*);
typedef BOOL (WINAPI *FPWLXINITIALIZE)(LPWSTR,HANDLE,PVOID,PVOID, 
                                       PVOID*);
typedef VOID (WINAPI *FPWLXDISPLAYSASNOTICE)(PVOID);
typedef int  (WINAPI *FPWLXLOGGEDOUTSAS)(PVOID,DWORD,PLUID,PSID,
                                         PDWORD,PHANDLE, 
                                         PWLX_MPR_NOTIFY_INFO, 
                                         PVOID *);
typedef BOOL (WINAPI *FPWLXACTIVATEUSERSHELL)(PVOID,PWSTR,PWSTR, 
                                              PVOID);
typedef int  (WINAPI *FPWLXLOGGEDONSAS)(PVOID,DWORD,PVOID);
typedef VOID (WINAPI *FPWLXDISPLAYLOCKEDNOTICE)(PVOID);
typedef int  (WINAPI *FPWLXWKSTALOCKEDSAS)(PVOID,DWORD);
typedef BOOL (WINAPI *FPWLXISLOCKOK)(PVOID);
typedef BOOL (WINAPI *FPWLXISLOGOFFOK)(PVOID);
typedef VOID (WINAPI *FPWLXLOGOFF)(PVOID);
typedef VOID (WINAPI *FPWLXSHUTDOWN)(PVOID, DWORD);

// 1.1 GINA entrypoints

typedef BOOL (WINAPI *FPWLXSCREENSAVERNOTIFY)(PVOID,BOOL *);
typedef BOOL (WINAPI *FPWLXSTARTAPPLICATION)(PVOID,PWSTR,PVOID,PWSTR);

// 1.3 GINA entrypoints
#if (WINVER >= 0x0500)
typedef BOOL (WINAPI *FPWLXNETWORKPROVIDERLOAD)(PVOID, 
                                                PWLX_MPR_NOTIFY_INFO);
typedef BOOL (WINAPI *FPWLXDISPLAYNOTICE)(PVOID, 
                                          WLX_NOTICE_TYPE);
typedef BOOL (WINAPI *FPWLXDISPLAYSTATUSMESSAGE)(PVOID,HDESK, 
												 PWSTR, PWSTR);
typedef BOOL (WINAPI *FPWLXGETSTATUSMESSAGE)(PVOID,PWSTR,DWORD);
typedef BOOL (WINAPI *FPWLXREMOVESTATUSMESSAGE)(PVOID);			 
#endif
